Arbor 3: FSM & BT Graph Editor 3.6.0

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Properties | Events | List of all members
NodeGraph Class Referenceabstract

ノードグラフの基本クラス。 More...

Inheritance diagram for NodeGraph:

## Public Member Functions
Node | GetNodeFromIndex (int index)
| Nodeをインデックスから取得 More...
Node | GetNodeFromID (int nodeID)
| ノードIDを指定してArbor.Nodeを取得する。 More...
CalculatorNode | GetCalculatorFromIndex (int index)
| CalculatorNodeをインデックスから取得 More...
int | GetCalculatorIndex (CalculatorNode calculator)
| CalculatorNodeのインデックスを取得 More...
CalculatorNode | GetCalculatorFromID (int calculatorID)
| 演算ノードIDを指定してArbor.CalculatorNodeを取得する。 More...
CalculatorNode | CreateCalculator (int nodeID, System.Type calculatorType)
| 演算ノードを生成。 More...
CalculatorNode | CreateCalculator (System.Type calculatorType)
| 演算ノードを生成。 More...
CalculatorNode | FindCalculator (Calculator calculator)
| Calculatorが属しているCalculatorNodeの取得。 More...
bool | DeleteCalculator (CalculatorNode calculatorNode)
| 演算ノードの削除。 More...
CommentNode | GetCommentFromIndex (int index)
| CommentNodeをインデックスから取得 More...
int | GetCommentIndex (CommentNode comment)
| CommentNodeのインデックスを取得 More...
CommentNode | GetCommentFromID (int commentID)
| コメントIDを指定してArbor.CommentNodeを取得する。 More...
CommentNode | CreateComment (int nodeID)
| コメントを生成。 More...
CommentNode | CreateComment ()
| コメントを生成。 More...
void | DeleteComment (CommentNode comment)
| コメントの削除。 More...
GroupNode | GetGroupFromIndex (int index)
| GroupNodeをインデックスから取得 More...
GroupNode | CreateGroup (int nodeID)
| グループを生成。 More...
GroupNode | CreateGroup ()
| グループを生成。 More...
void | DeleteGroup (GroupNode group)
| グループの削除。 More...
GroupNode | GetGroupFromID (int groupID)
| グループIDを指定してArbor.GroupNodeを取得する。 More...
DataBranchRerouteNode | CreateDataBranchRerouteNode (Vector2 position, System.Type type, int nodeID)
| DataBranchRerouteNodeを生成。 More...
DataBranchRerouteNode | CreateCalculatorBranchRerouteNode (Vector2 position, System.Type type, int nodeID)
| DataBranchRerouteNodeを生成。 More...
DataBranchRerouteNode | CreateDataBranchRerouteNode (Vector2 position, System.Type type)
| DataBranchRerouteNodeを生成。 More...
DataBranchRerouteNode | CreateCalculatorBranchRerouteNode (Vector2 position, System.Type type)
| DataBranchRerouteNodeを生成。 More...
void | DeleteDataBranchRerouteNode (DataBranchRerouteNode rerouteNode)
| DataBranchRerouteNodeの削除。 More...
void | DeleteCalculatorBranchRerouteNode (DataBranchRerouteNode rerouteNode)
| DataBranchRerouteNodeの削除。 More...
virtual void | OnValidateNodes ()
| ノードが変更された際に呼ばれる。 More...
bool | DeleteNode (Node node)
| ノードの削除。 More...
Node | FindNodeContainsBehaviour (NodeBehaviour behaviour)
| NodeBehaviourが属しているノードの取得。 More...
DataBranch | GetDataBranchFromIndex (int index)
| DataBranchをインデックスから取得 More...
DataBranch | GetCalculatorBranchFromIndex (int index)
| DataBranchをインデックスから取得 More...
int | GetDataBranchIndex (DataBranch branch)
| DataBranchのインデックスを取得 More...
int | GetCalculatorBranchIndex (DataBranch branch)
| DataBranchのインデックスを取得 More...
DataBranch | GetDataBranchFromID (int branchID)
| 演算ブランチIDを指定してArbor.DataBranchを取得する。 More...
DataBranch | GetCalculatorBranchFromID (int branchID)
| 演算ブランチIDを指定してArbor.DataBranchを取得する。 More...
DataBranch | ConnectDataBranch (int branchID, int inputNodeID, Object inputObj, DataSlot inputSlot, int outputNodeID, Object outputObj, DataSlot outputSlot)
| DataSlotの接続 More...
DataBranch | ConnectCalculatorBranch (int branchID, int inputNodeID, Object inputObj, DataSlot inputSlot, int outputNodeID, Object outputObj, DataSlot outputSlot)
| DataSlotの接続 More...
DataBranch | ConnectDataBranch (int inputNodeID, Object inputObj, DataSlot inputSlot, int outputNodeID, Object outputObj, DataSlot outputSlot)
| DataSlotの接続 More...
DataBranch | ConnectCalculatorBranch (int inputNodeID, Object inputObj, DataSlot inputSlot, int outputNodeID, Object outputObj, DataSlot outputSlot)
| DataSlotの接続 More...
void | DisconnectDataBranch (Object obj)
| 内部的に使用するメソッド。特に呼び出す必要はありません。 More...
void | DeleteDataBranch (DataBranch branch)
| DataBranchの削除。 More...
void | DeleteCalculatorBranch (DataBranch branch)
| DataBranchの削除。 More...
bool | CheckLoopDataBranch (int inputNodeID, Object inputObj, int outputNodeID, Object outputObj)
| DataBranchがループしているかをチェックする。 More...
bool | CheckLoopCalculatorBranch (int inputNodeID, Object inputObj, int outputNodeID, Object outputObj)
| DataBranchがループしているかをチェックする。 More...
delegate void | NodeGraphCallback (NodeGraph nodeGraph)
| NodeGraphのコールバック用デリゲート More...
void | DestroySubComponents ()
| 内部的に使用するメソッド。特に呼び出す必要はありません。 More...
override string | ToString ()
| グラフを文字列に変換（デバッグ用）。 More...
void | OnPoolResume ()
| 再開する際に呼ばれる。 More...
void | OnPoolSleep ()
| プールに格納された際に呼ばれる。 More...

## Static Public Member Functions
static NodeGraph | FindGraph (string name)
| シーン内にあるNodeGraphを名前で取得する。 More...
static NodeGraph | FindGraph (string name, System.Type type)
| シーン内にあるNodeGraphを名前で取得する。 More...
static T | FindGraph< T > (string name)
| シーン内にあるNodeGraphを名前で取得する。 More...
static NodeGraph [] | FindGraphs (string name)
| シーン内にある同一名のNodeGraphを取得する。 More...
static NodeGraph [] | FindGraphs (string name, System.Type type)
| シーン内にある同一名のNodeGraphを取得する。 More...
static T [] | FindGraphs< T > (string name)
| シーン内にある同一名のNodeGraphを取得する。 More...
static NodeGraph | FindGraph (GameObject gameObject, string name)
| GameObjectにアタッチされているNodeGraphを名前で取得する。 More...
static NodeGraph | FindGraph (GameObject gameObject, string name, System.Type type)
| GameObjectにアタッチされているNodeGraphを名前で取得する。 More...
static T | FindGraph< T > (GameObject gameObject, string name)
| GameObjectにアタッチされているNodeGraphを名前で取得する。 More...
static NodeGraph [] | FindGraphs (GameObject gameObject, string name)
| GameObjectにアタッチされている同一名のNodeGraphを取得する。 More...
static NodeGraph [] | FindGraphs (GameObject gameObject, string name, System.Type type)
| GameObjectにアタッチされている同一名のNodeGraphを取得する。 More...
static T [] | FindGraphs< T > (GameObject gameObject, string name)
| GameObjectにアタッチされている同一名のNodeGraphを取得する。 More...
static NodeGraph | Create (GameObject gameObject, System.Type classType)
| NodeGraphの作成 More...
static GraphType | Create< GraphType > (GameObject gameObject)
| NodeGraphの作成 More...
static NodeGraph | Instantiate (NodeGraph sourceGraph, NodeBehaviour ownerBehaviour, bool usePool=false)
| NodeGraphを生成 More...
static GraphType | Instantiate< GraphType > (GraphType sourceGraph, NodeBehaviour ownerBehaviour, bool usePool=false)
| NodeGraphを生成 More...
static void | Destroy (NodeGraph nodeGraph)
| NodeGraphの破棄 More...

## Public Attributes
string | graphName = ""
| グラフの名前。 一つのGameObjectに複数のグラフがある場合の識別や検索に使用する。 More...
DebugInfiniteLoopSettings | debugInfiniteLoopSettings = new DebugInfiniteLoopSettings()
| 無限ループのデバッグ設定 More...

## Protected Member Functions
abstract bool | OnDeleteNode (Node node)
| ノードの削除。 More...
virtual void | OnValidate ()
| MonoBehaviour.OnValidate を参照してください More...
virtual void | OnReset ()
| Resetもしくは生成時のコールバック。 More...

## Properties
NodeGraph | parentGraph`[get]`
| 親グラフ More...
NodeGraph | rootGraph`[get]`
| ルートグラフ More...
Object | ownerBehaviourObject`[get, set]`
| このグラフの所有者であるNodeBehaviourのObject More...
NodeBehaviour | ownerBehaviour`[get, set]`
| このグラフの所有者であるNodeBehaviour More...
ParameterContainerInternal | parameterContainer`[get]`
| このグラフ内に割り当てられているParameterContainer More...
string | displayGraphName`[get]`
| ノードグラフの表示名。graphNameが空かnullの場合は"(No Name)"を返す。 More...
DebugInfiniteLoopSettings | currentDebugInfiniteLoopSettings`[get]`
| 現在の無限ループデバッグ設定。 More...
bool | external`[get]`
| 外部グラフから生成されたフラグ More...
int | nodeCount`[get]`
| Nodeの数を取得。 More...
int | calculatorCount`[get]`
| CalculatorNodeの数を取得。 More...
CalculatorNode [] | calculators`[get]`
| 全てのArbor.CalculatorNodeを取得する。 More...
int | commentCount`[get]`
| CommentNodeの数を取得。 More...
CommentNode [] | comments`[get]`
| 全てのArbor.CommentNodeを取得する。 More...
int | groupCount`[get]`
| GroupNodeの数を取得。 More...
DataBranchRerouteNodeList | dataBranchRerouteNodes`[get]`
| DataBranchRerouteNodeリスト More...
DataBranchRerouteNodeList | calculatorBranchRerouteNodes`[get]`
| DataBranchRerouteNodeリスト More...
int | dataBranchCount`[get]`
| DataBranchの数を取得。 More...
int | calculatorBranchCount`[get]`
| DataBranchの数を取得。 More...
DataBranch [] | calculatorBranchies`[get]`
| 全てのArbor.DataBranchを取得する。 More...
bool | isDeserialized`[get]`
| デシリアライズ済みかどうかを返す。 More...

## Events
System.Action | onAfterDeserialize
| デシリアライズ後のコールバック More...
NodeGraphCallback | destroyCallback
| 破棄される際のコールバック More...
NodeGraphCallback | stateChangedCallback
| 状態が変わった際のコールバック More...

## Detailed Description

ノードグラフの基本クラス。

## Member Function Documentation

## ◆ CheckLoopCalculatorBranch()

bool CheckLoopCalculatorBranch | ( | int | inputNodeID,
|  | Object | inputObj,
|  | int | outputNodeID,
|  | Object | outputObj
| ) |  |

DataBranchがループしているかをチェックする。

Parameters

  inputNodeID | 入力スロット側ノードID
  inputObj | 入力スロット側Object
  outputNodeID | 出力スロット側ノードID
  outputObj | 出力スロット側Object

Returns
  ループしている場合はtrueを返す。

## ◆ CheckLoopDataBranch()

bool CheckLoopDataBranch | ( | int | inputNodeID,
|  | Object | inputObj,
|  | int | outputNodeID,
|  | Object | outputObj
| ) |  |

DataBranchがループしているかをチェックする。

Parameters

  inputNodeID | 入力スロット側ノードID
  inputObj | 入力スロット側Object
  outputNodeID | 出力スロット側ノードID
  outputObj | 出力スロット側Object

Returns
  ループしている場合はtrueを返す。

## ◆ ConnectCalculatorBranch() [1/2]

DataBranch ConnectCalculatorBranch | ( | int | branchID,
|  | int | inputNodeID,
|  | Object | inputObj,
|  | DataSlot | inputSlot,
|  | int | outputNodeID,
|  | Object | outputObj,
|  | DataSlot | outputSlot
| ) |  |

DataSlotの接続

Parameters

  branchID | 作成するDataBranchのID
  inputNodeID | 入力ノードID
  inputObj | 入力オブジェクト
  inputSlot | 入力スロット
  outputNodeID | 出力ノードID
  outputObj | 出力オブジェクト
  outputSlot | 出力スロット

Returns
  接続したDataBranch

## ◆ ConnectCalculatorBranch() [2/2]

DataBranch ConnectCalculatorBranch | ( | int | inputNodeID,
|  | Object | inputObj,
|  | DataSlot | inputSlot,
|  | int | outputNodeID,
|  | Object | outputObj,
|  | DataSlot | outputSlot
| ) |  |

DataSlotの接続

Parameters

  inputNodeID | 入力ノードID
  inputObj | 入力オブジェクト
  inputSlot | 入力スロット
  outputNodeID | 出力ノードID
  outputObj | 出力オブジェクト
  outputSlot | 出力スロット

Returns
  接続したDataBranch

## ◆ ConnectDataBranch() [1/2]

DataBranch ConnectDataBranch | ( | int | branchID,
|  | int | inputNodeID,
|  | Object | inputObj,
|  | DataSlot | inputSlot,
|  | int | outputNodeID,
|  | Object | outputObj,
|  | DataSlot | outputSlot
| ) |  |

DataSlotの接続

Parameters

  branchID | 作成するDataBranchのID
  inputNodeID | 入力ノードID
  inputObj | 入力オブジェクト
  inputSlot | 入力スロット
  outputNodeID | 出力ノードID
  outputObj | 出力オブジェクト
  outputSlot | 出力スロット

Returns
  接続したDataBranch

## ◆ ConnectDataBranch() [2/2]

DataBranch ConnectDataBranch | ( | int | inputNodeID,
|  | Object | inputObj,
|  | DataSlot | inputSlot,
|  | int | outputNodeID,
|  | Object | outputObj,
|  | DataSlot | outputSlot
| ) |  |

DataSlotの接続

Parameters

  inputNodeID | 入力ノードID
  inputObj | 入力オブジェクト
  inputSlot | 入力スロット
  outputNodeID | 出力ノードID
  outputObj | 出力オブジェクト
  outputSlot | 出力スロット

Returns
  接続したDataBranch

## ◆ Create()

static NodeGraph Create | ( | GameObject | gameObject,
|  | System.Type | classType
| ) |  |
| static

NodeGraphの作成

Parameters

  gameObject | GameObject
  classType | NodeGraphの型

Returns
  作成したNodeGraph

## ◆ Create< GraphType >()

static GraphType Create< GraphType > | ( | GameObject | gameObject | ) |
| static

NodeGraphの作成

Template Parameters

  GraphType | NodeGraphの型

Parameters

  gameObject | GameObject

Returns
  作成したNodeGraph

Type Constraints

  GraphType | : | NodeGraph |

## ◆ CreateCalculator() [1/2]

CalculatorNode CreateCalculator | ( | int | nodeID,
|  | System.Type | calculatorType
| ) |  |

演算ノードを生成。

Parameters

  nodeID | ノード ID
  calculatorType | Calculatorの型

Returns
  生成した演算ノード。ノードIDが重複している場合は生成せずにnullを返す。

## ◆ CreateCalculator() [2/2]

CalculatorNode CreateCalculator | ( | System.Type | calculatorType | ) |

演算ノードを生成。

Parameters

  calculatorType | Calculatorの型

Returns
  生成した演算ノード。

## ◆ CreateCalculatorBranchRerouteNode() [1/2]

DataBranchRerouteNode CreateCalculatorBranchRerouteNode | ( | Vector2 | position,
|  | System.Type | type,
|  | int | nodeID
| ) |  |

DataBranchRerouteNodeを生成。

Parameters

  position | ノードの位置
  type | 値の型
  nodeID | ノード ID

Returns
  生成したDataBranchRerouteNode。ノードIDが重複している場合は生成せずにnullを返す。

## ◆ CreateCalculatorBranchRerouteNode() [2/2]

DataBranchRerouteNode CreateCalculatorBranchRerouteNode | ( | Vector2 | position,
|  | System.Type | type
| ) |  |

DataBranchRerouteNodeを生成。

Returns
  生成したDataBranchRerouteNode。

## ◆ CreateComment() [1/2]

CommentNode CreateComment | ( | int | nodeID | ) |

コメントを生成。

Parameters

  nodeID | ノードID

Returns
  生成したコメント。ノードIDが重複している場合は生成せずにnullを返す。

## ◆ CreateComment() [2/2]

CommentNode CreateComment | ( |  | ) |

コメントを生成。

Returns
  生成したコメント。

## ◆ CreateDataBranchRerouteNode() [1/2]

DataBranchRerouteNode CreateDataBranchRerouteNode | ( | Vector2 | position,
|  | System.Type | type,
|  | int | nodeID
| ) |  |

DataBranchRerouteNodeを生成。

Parameters

  position | ノードの位置
  type | 値の型
  nodeID | ノード ID

Returns
  生成したDataBranchRerouteNode。ノードIDが重複している場合は生成せずにnullを返す。

## ◆ CreateDataBranchRerouteNode() [2/2]

DataBranchRerouteNode CreateDataBranchRerouteNode | ( | Vector2 | position,
|  | System.Type | type
| ) |  |

DataBranchRerouteNodeを生成。

Returns
  生成したDataBranchRerouteNode。

## ◆ CreateGroup() [1/2]

GroupNode CreateGroup | ( | int | nodeID | ) |

グループを生成。

Parameters

  nodeID | ノード ID

Returns
  生成したグループ。ノードIDが重複している場合は生成せずにnullを返す。

## ◆ CreateGroup() [2/2]

GroupNode CreateGroup | ( |  | ) |

グループを生成。

Returns
  生成したグループ。

## ◆ DeleteCalculator()

bool DeleteCalculator | ( | CalculatorNode | calculatorNode | ) |

演算ノードの削除。

Parameters

  calculatorNode | 削除する演算ノード。

Returns
  削除した場合にtrue

## ◆ DeleteCalculatorBranch()

void DeleteCalculatorBranch | ( | DataBranch | branch | ) |

DataBranchの削除。

Parameters

  branch | 削除するDataBranch。

## ◆ DeleteCalculatorBranchRerouteNode()

void DeleteCalculatorBranchRerouteNode | ( | DataBranchRerouteNode | rerouteNode | ) |

DataBranchRerouteNodeの削除。

Parameters

  rerouteNode | 削除するDataBranchRerouteNode。

## ◆ DeleteComment()

void DeleteComment | ( | CommentNode | comment | ) |

コメントの削除。

Parameters

  comment | 削除するコメント。

## ◆ DeleteDataBranch()

void DeleteDataBranch | ( | DataBranch | branch | ) |

DataBranchの削除。

Parameters

  branch | 削除するDataBranch。

## ◆ DeleteDataBranchRerouteNode()

void DeleteDataBranchRerouteNode | ( | DataBranchRerouteNode | rerouteNode | ) |

DataBranchRerouteNodeの削除。

Parameters

  rerouteNode | 削除するDataBranchRerouteNode。

## ◆ DeleteGroup()

void DeleteGroup | ( | GroupNode | group | ) |

グループの削除。

Parameters

  group | 削除するグループ。

## ◆ DeleteNode()

bool DeleteNode | ( | Node | node | ) |

ノードの削除。

Parameters

  node | 削除するノード。

Returns
  削除した場合にtrue

## ◆ Destroy()

static void Destroy | ( | NodeGraph | nodeGraph | ) |
| static

NodeGraphの破棄

Parameters

  nodeGraph | NodeGraph

## ◆ DestroySubComponents()

void DestroySubComponents | ( |  | ) |

内部的に使用するメソッド。特に呼び出す必要はありません。

## ◆ DisconnectDataBranch()

void DisconnectDataBranch | ( | Object | obj | ) |

内部的に使用するメソッド。特に呼び出す必要はありません。

## ◆ FindCalculator()

CalculatorNode FindCalculator | ( | Calculator | calculator | ) |

Calculatorが属しているCalculatorNodeの取得。

Parameters

  calculator | Calculator

Returns
  Calculatorが属しているCalculatorNode。ない場合はnullを返す。

## ◆ FindGraph() [1/4]

static NodeGraph FindGraph | ( | string | name | ) |
| static

シーン内にあるNodeGraphを名前で取得する。

Parameters

  name | 検索するNodeGraphの名前。

Returns
  見つかったNodeGraph。見つからなかった場合はnullを返す。

## ◆ FindGraph() [2/4]

static NodeGraph FindGraph | ( | string | name,
|  | System.Type | type
| ) |  |
| static

シーン内にあるNodeGraphを名前で取得する。

Parameters

  name | 検索するNodeGraphの名前。
  type | 検索するNodeGraphのType。

Returns
  見つかったNodeGraph。見つからなかった場合はnullを返す。

## ◆ FindGraph() [3/4]

static NodeGraph FindGraph | ( | GameObject | gameObject,
|  | string | name
| ) |  |
| static

GameObjectにアタッチされているNodeGraphを名前で取得する。

Parameters

  gameObject | 検索したいGameObject。
  name | 検索するNodeGraphの名前。

Returns
  見つかったNodeGraph。見つからなかった場合はnullを返す。

## ◆ FindGraph() [4/4]

static NodeGraph FindGraph | ( | GameObject | gameObject,
|  | string | name,
|  | System.Type | type
| ) |  |
| static

GameObjectにアタッチされているNodeGraphを名前で取得する。

Parameters

  gameObject | 検索したいGameObject。
  name | 検索するNodeGraphの名前。
  type | 検索するNodeGraphのType。

Returns
  見つかったNodeGraph。見つからなかった場合はnullを返す。

## ◆ FindGraph< T >() [1/2]

static T FindGraph< T > | ( | string | name | ) |
| static

シーン内にあるNodeGraphを名前で取得する。

Template Parameters

  T | 検索するNodeGraphのType。

Parameters

  name | 検索するNodeGraphの名前。

Returns
  見つかったNodeGraph。見つからなかった場合はnullを返す。

Type Constraints

  T | : | NodeGraph |

## ◆ FindGraph< T >() [2/2]

static T FindGraph< T > | ( | GameObject | gameObject,
|  | string | name
| ) |  |
| static

GameObjectにアタッチされているNodeGraphを名前で取得する。

Template Parameters

  T | 検索するNodeGraphのType。

Parameters

  gameObject | 検索したいGameObject。
  name | 検索するNodeGraphの名前。

Returns
  見つかったNodeGraph。見つからなかった場合はnullを返す。

Type Constraints

  T | : | NodeGraph |

## ◆ FindGraphs() [1/4]

static NodeGraph [] FindGraphs | ( | string | name | ) |
| static

シーン内にある同一名のNodeGraphを取得する。

Parameters

  name | 検索するNodeGraphの名前。

Returns
  見つかったNodeGraphの配列。

## ◆ FindGraphs() [2/4]

static NodeGraph [] FindGraphs | ( | string | name,
|  | System.Type | type
| ) |  |
| static

シーン内にある同一名のNodeGraphを取得する。

Parameters

  name | 検索するNodeGraphの名前。
  type | 検索するNodeGraphのType。

Returns
  見つかったNodeGraphの配列。

## ◆ FindGraphs() [3/4]

static NodeGraph [] FindGraphs | ( | GameObject | gameObject,
|  | string | name
| ) |  |
| static

GameObjectにアタッチされている同一名のNodeGraphを取得する。

Parameters

  gameObject | 検索したいGameObject。
  name | 検索するNodeGraphの名前。

Returns
  見つかったNodeGraphの配列。

## ◆ FindGraphs() [4/4]

static NodeGraph [] FindGraphs | ( | GameObject | gameObject,
|  | string | name,
|  | System.Type | type
| ) |  |
| static

GameObjectにアタッチされている同一名のNodeGraphを取得する。

Parameters

  gameObject | 検索したいGameObject。
  name | 検索するNodeGraphの名前。
  type | 検索するNodeGraphのType。

Returns
  見つかったNodeGraphの配列。

## ◆ FindGraphs< T >() [1/2]

static T [] FindGraphs< T > | ( | string | name | ) |
| static

シーン内にある同一名のNodeGraphを取得する。

Template Parameters

  T | 検索するNodeGraphのType。

Parameters

  name | 検索するNodeGraphの名前。

Returns
  見つかったNodeGraphの配列。

Type Constraints

  T | : | NodeGraph |

## ◆ FindGraphs< T >() [2/2]

static T [] FindGraphs< T > | ( | GameObject | gameObject,
|  | string | name
| ) |  |
| static

GameObjectにアタッチされている同一名のNodeGraphを取得する。

Template Parameters

  T | 検索するNodeGraphのType。

Parameters

  gameObject | 検索したいGameObject。
  name | 検索するNodeGraphの名前。

Returns
  見つかったNodeGraphの配列。

Type Constraints

  T | : | NodeGraph |

## ◆ FindNodeContainsBehaviour()

Node FindNodeContainsBehaviour | ( | NodeBehaviour | behaviour | ) |

NodeBehaviourが属しているノードの取得。

Parameters

  behaviour | NodeBehaviour

Returns
  NodeBehaviourが属しているノード。ない場合はnullを返す。

## ◆ GetCalculatorBranchFromID()

DataBranch GetCalculatorBranchFromID | ( | int | branchID | ) |

演算ブランチIDを指定してArbor.DataBranchを取得する。

Parameters

  branchID | 演算ブランチID

Returns
  見つかったArbor.DataBranch。見つからなかった場合はnullを返す。

## ◆ GetCalculatorBranchFromIndex()

DataBranch GetCalculatorBranchFromIndex | ( | int | index | ) |

DataBranchをインデックスから取得

Parameters

  index | インデックス

Returns
  DataBranch

## ◆ GetCalculatorBranchIndex()

int GetCalculatorBranchIndex | ( | DataBranch | branch | ) |

DataBranchのインデックスを取得

Parameters

  branch | DataBranch

Returns
  インデックス。ない場合は-1を返す。

## ◆ GetCalculatorFromID()

CalculatorNode GetCalculatorFromID | ( | int | calculatorID | ) |

演算ノードIDを指定してArbor.CalculatorNodeを取得する。

Parameters

  calculatorID | 演算ノードID

Returns
  見つかったArbor.CalculatorNode。見つからなかった場合はnullを返す。

## ◆ GetCalculatorFromIndex()

CalculatorNode GetCalculatorFromIndex | ( | int | index | ) |

CalculatorNodeをインデックスから取得

Parameters

  index | インデックス

Returns
  CalculatorNode

## ◆ GetCalculatorIndex()

int GetCalculatorIndex | ( | CalculatorNode | calculator | ) |

CalculatorNodeのインデックスを取得

Parameters

  calculator | CalculatorNode

Returns
  インデックス。ない場合は-1を返す。

## ◆ GetCommentFromID()

CommentNode GetCommentFromID | ( | int | commentID | ) |

コメントIDを指定してArbor.CommentNodeを取得する。

Parameters

  commentID | コメントID

Returns
  見つかったArbor.CommentNode。見つからなかった場合はnullを返す。

## ◆ GetCommentFromIndex()

CommentNode GetCommentFromIndex | ( | int | index | ) |

CommentNodeをインデックスから取得

Parameters

  index | インデックス

Returns
  CommentNode

## ◆ GetCommentIndex()

int GetCommentIndex | ( | CommentNode | comment | ) |

CommentNodeのインデックスを取得

Parameters

  comment | CommentNode

Returns
  インデックス。ない場合は-1を返す。

## ◆ GetDataBranchFromID()

DataBranch GetDataBranchFromID | ( | int | branchID | ) |

演算ブランチIDを指定してArbor.DataBranchを取得する。

Parameters

  branchID | 演算ブランチID

Returns
  見つかったArbor.DataBranch。見つからなかった場合はnullを返す。

## ◆ GetDataBranchFromIndex()

DataBranch GetDataBranchFromIndex | ( | int | index | ) |

DataBranchをインデックスから取得

Parameters

  index | インデックス

Returns
  DataBranch

## ◆ GetDataBranchIndex()

int GetDataBranchIndex | ( | DataBranch | branch | ) |

DataBranchのインデックスを取得

Parameters

  branch | DataBranch

Returns
  インデックス。ない場合は-1を返す。

## ◆ GetGroupFromID()

GroupNode GetGroupFromID | ( | int | groupID | ) |

グループIDを指定してArbor.GroupNodeを取得する。

Parameters

  groupID | グループID

Returns
  見つかったArbor.GroupNode。見つからなかった場合はnullを返す。

## ◆ GetGroupFromIndex()

GroupNode GetGroupFromIndex | ( | int | index | ) |

GroupNodeをインデックスから取得

Parameters

  index | インデックス

Returns
  GroupNode

## ◆ GetNodeFromID()

Node GetNodeFromID | ( | int | nodeID | ) |

ノードIDを指定してArbor.Nodeを取得する。

Parameters

  nodeID | ノードID

Returns
  見つかったArbor.Node。見つからなかった場合はnullを返す。

## ◆ GetNodeFromIndex()

Node GetNodeFromIndex | ( | int | index | ) |

Nodeをインデックスから取得

Parameters

  index | インデックス

Returns
  Node

## ◆ Instantiate()

static NodeGraph Instantiate | ( | NodeGraph | sourceGraph,
|  | NodeBehaviour | ownerBehaviour,
|  | bool | usePool = `false`
| ) |  |
| static

NodeGraphを生成

Parameters

  sourceGraph | 生成元のグラフ
  ownerBehaviour | グラフの所有権を持つNodeBehaviour
  usePool | ObjectPoolを使用してインスタンス化するフラグ。

Returns
  生成したグラフ

## ◆ Instantiate< GraphType >()

static GraphType Instantiate< GraphType > | ( | GraphType | sourceGraph,
|  | NodeBehaviour | ownerBehaviour,
|  | bool | usePool = `false`
| ) |  |
| static

NodeGraphを生成

Template Parameters

  GraphType | グラフの型

Parameters

  sourceGraph | 生成元のグラフ
  ownerBehaviour | グラフの所有権を持つNodeBehaviour
  usePool | ObjectPoolを使用してインスタンス化するフラグ。

Returns
  生成したグラフ

Type Constraints

  GraphType | : | NodeGraph |

## ◆ NodeGraphCallback()

delegate void NodeGraphCallback | ( | NodeGraph | nodeGraph | ) |

NodeGraphのコールバック用デリゲート

Parameters

  nodeGraph | イベントが起きたNodeGraph

## ◆ OnDeleteNode()

abstract bool OnDeleteNode | ( | Node | node | ) |
| protected pure virtual

ノードの削除。

Parameters

  node | 削除するノード

Returns
  削除した場合はtrue、していなければfalseを返す。

Implemented in ArborFSMInternal, and BehaviourTreeInternal.

## ◆ OnPoolResume()

void OnPoolResume | ( |  | ) |

再開する際に呼ばれる。

Implements IPoolCallbackReceiver.

## ◆ OnPoolSleep()

void OnPoolSleep | ( |  | ) |

プールに格納された際に呼ばれる。

Implements IPoolCallbackReceiver.

## ◆ OnReset()

virtual void OnReset | ( |  | ) |
| protected virtual

Resetもしくは生成時のコールバック。

Reimplemented in ArborFSMInternal, and BehaviourTreeInternal.

## ◆ OnValidate()

virtual void OnValidate | ( |  | ) |
| protected virtual

MonoBehaviour.OnValidate を参照してください

Reimplemented in ArborFSMInternal.

## ◆ OnValidateNodes()

virtual void OnValidateNodes | ( |  | ) |
| virtual

ノードが変更された際に呼ばれる。

Reimplemented in BehaviourTreeInternal.

## ◆ ToString()

override string ToString | ( |  | ) |

グラフを文字列に変換（デバッグ用）。

Returns
  変換された文字列

## Member Data Documentation

## ◆ debugInfiniteLoopSettings

DebugInfiniteLoopSettings debugInfiniteLoopSettings = new DebugInfiniteLoopSettings()

無限ループのデバッグ設定

## ◆ graphName

string graphName = ""

グラフの名前。
一つのGameObjectに複数のグラフがある場合の識別や検索に使用する。

## Property Documentation

## ◆ calculatorBranchCount

int calculatorBranchCount
| get

DataBranchの数を取得。

## ◆ calculatorBranchies

DataBranch [] calculatorBranchies
| get

全てのArbor.DataBranchを取得する。

## ◆ calculatorBranchRerouteNodes

DataBranchRerouteNodeList calculatorBranchRerouteNodes
| get

DataBranchRerouteNodeリスト

## ◆ calculatorCount

int calculatorCount
| get

CalculatorNodeの数を取得。

## ◆ calculators

CalculatorNode [] calculators
| get

全てのArbor.CalculatorNodeを取得する。

## ◆ commentCount

int commentCount
| get

CommentNodeの数を取得。

## ◆ comments

CommentNode [] comments
| get

全てのArbor.CommentNodeを取得する。

## ◆ currentDebugInfiniteLoopSettings

DebugInfiniteLoopSettings currentDebugInfiniteLoopSettings
| get

現在の無限ループデバッグ設定。

子グラフの場合はルートグラフの無限ループデバッグ設定を返す。

## ◆ dataBranchCount

int dataBranchCount
| get

DataBranchの数を取得。

## ◆ dataBranchRerouteNodes

DataBranchRerouteNodeList dataBranchRerouteNodes
| get

DataBranchRerouteNodeリスト

## ◆ displayGraphName

string displayGraphName
| get

ノードグラフの表示名。graphNameが空かnullの場合は"(No Name)"を返す。

## ◆ external

bool external
| get

外部グラフから生成されたフラグ

## ◆ groupCount

int groupCount
| get

GroupNodeの数を取得。

## ◆ isDeserialized

bool isDeserialized
| get

デシリアライズ済みかどうかを返す。

## ◆ nodeCount

int nodeCount
| get

Nodeの数を取得。

## ◆ ownerBehaviour

NodeBehaviour ownerBehaviour
| get set

このグラフの所有者であるNodeBehaviour

## ◆ ownerBehaviourObject

Object ownerBehaviourObject
| get set

このグラフの所有者であるNodeBehaviourのObject

## ◆ parameterContainer

ParameterContainerInternal parameterContainer
| get

このグラフ内に割り当てられているParameterContainer

## ◆ parentGraph

NodeGraph parentGraph
| get

親グラフ

## ◆ rootGraph

NodeGraph rootGraph
| get

ルートグラフ

## Event Documentation

## ◆ destroyCallback

NodeGraphCallback destroyCallback

破棄される際のコールバック

## ◆ onAfterDeserialize

System.Action onAfterDeserialize

デシリアライズ後のコールバック

## ◆ stateChangedCallback

NodeGraphCallback stateChangedCallback

状態が変わった際のコールバック